#include <iostream>
using namespace std;

int main() {
    int N, Q;
    cin >> N >> Q;

    long long ukupno_pakovanja = 0, poslednji_dan = 0;

    int trenutni_dan, trenutni_paketi;
    cin >> trenutni_dan >> trenutni_paketi;

    for (int i = 0; i < Q; i++) {
        int k;
        cin >> k;

        while (N > 0 && trenutni_dan <= k) {
            ukupno_pakovanja += trenutni_paketi;
            poslednji_dan = trenutni_dan;
            N--;
            if (N > 0) cin >> trenutni_dan >> trenutni_paketi;
        }

        long long dana_proslo = k - poslednji_dan;
        if (ukupno_pakovanja >= dana_proslo) {
            cout << dana_proslo << endl;
            ukupno_pakovanja -= dana_proslo;
        } else {
            cout << ukupno_pakovanja << endl;
            ukupno_pakovanja = 0;
        }
        poslednji_dan = k;
    }

    return 0;
}